<?php
/*
Plugin Name: DW Post Navigation
Plugin URI: https://disweb.ru/plugins-dw/wordpress-plugins-dw/dw-post-nav/
Description: Шаблон навигации следующая/предыдущая запись
Version: 1.0.1
Author: DisWEB
Author URI: https://disweb.ru
Text Domain: wp-pagenavi
*/

if( !function_exists( 'dw_post_nav' ) ){
	function dw_post_nav_get_post( $previous = true ){
		return get_adjacent_post( false, '', $previous, 'category' );
	}

	function dw_post_nav_get_image_data( &$post ){
		return wp_get_attachment_image_src( get_post_thumbnail_id( $post ), apply_filters( 'post_thumbnail_size', 'post-thumbnail', $post->ID ) );
	}

	function dw_post_nav(){
		$ar = [
			['previous', true],
			['next', false]
		];
		foreach( $ar as $v ){
			global $dwPostNav;
			$dwPostNav = dw_post_nav_get_post( $v[1] );
			if( $dwPostNav ){
				if( get_template_directory() . '/dw_post_nav/' . $v[0] . '.php' ){
					include( get_template_directory() . '/dw_post_nav/' . $v[0] . '.php' );
				}else{
					include( __DIR__ . '/template/' . $v[0] . '.php' );
				}
			}
		}
	}

	function dw_post_nav_get_previous(){
		global $dwPostNav;
		$dwPostNav = dw_post_nav_get_post( true );
		return $dwPostNav ? true : false;
	}

	function dw_post_nav_get_next(){
		global $dwPostNav;
		$dwPostNav = dw_post_nav_get_post( false );
		return $dwPostNav ? true : false;
	}
	
	function dw_post_nav_get_image_src(){
		global $dwPostNav;
		return dw_post_nav_get_image_data( $dwPostNav )[0];
	}
	
	function dw_post_nav_image_src(){
		echo dw_post_nav_get_image_src();
	}
	
	function dw_post_nav_get_url(){
		global $dwPostNav;
		return get_permalink( $dwPostNav );
	}
	
	function dw_post_nav_url(){
		echo dw_post_nav_get_url();
	}
	
	function dw_post_nav_get_title( $charLen = 0 ){
		global $dwPostNav;
		if( $charLen ){
			return mb_substr( strip_tags( $dwPostNav->post_title ), 0, $charLen );
		}else{
			return $dwPostNav->post_title;
		}
	}
	
	function dw_post_nav_title( $charLen = 0 ){
		echo dw_post_nav_get_title( $charLen );
	}
	
	function dw_post_nav_get_preview_text( $charLen = 50 ){
		global $dwPostNav;
		return mb_substr( strip_tags( $dwPostNav->post_content ), 0, $charLen );
	}
	
	function dw_post_nav_preview_text( $charLen = 50 ){
		echo dw_post_nav_get_preview_text( $charLen );
	}
}
